'#############################
'## ROZDZIAL 7 #################
'#############################
'## Filtr Kalmana ################
'##############################
'### (C) Andrzej Torj #############
'##############################

wfopen C:\zastosowania_ekonometrii_www\07\rozdzial_7.wf1

'FILTR KALMANA

smpl 2002q2 2015q3
vector(3) msys = 0
msys(1) = 5.3775
msys(2) = 0.01
msys(3) = 0.000796

sym(3) vsys = 0
vsys(1,1) = 0.001
vsys(2,2) = 0.001
vsys(3,3) = 0.001

sspace system_kalman

system_kalman.append @STATE YPOT = YPOT(-1) + DYPOT(-1) 
system_kalman.append @STATE DYPOT = c(1) * DYPOT(-1) + (1 - c(1)) * C(2) + [ename = e1]
system_kalman.append @STATE YGAP = C(3) * YGAP(-1) + [ename = e2]
system_kalman.append L_GDP_PL = YPOT + YGAP + [ename = e3]
system_kalman.append CPI_yy = C(4) + C(5) * YGAP + C(6) * CPI_YY(-1) + [ename = e4]

system_kalman.append @evar var(e1) = exp(c(7))
system_kalman.append @evar var(e2) = exp(c(8))
system_kalman.append @evar var(e3) = exp(c(9))
system_kalman.append @evar var(e4) = exp(c(10))

system_kalman.append @mprior msys
system_kalman.append @vprior vsys
system_kalman.append PARAM c(1) 0.9 c(2) 0.01 c(3) 0.7 c(4) 0.00625 c(5) 0.1 C(6) 0.5 C(7) -2 c(8) -2 c(9) -2 c(10) -2

system_kalman.ml
SHOW SYSTEM_KALMAN

'TWORZENIE GRAFIKI
'smpl 2005m1 2015m11
system_kalman.makestates(t = smooth) sm_sys_*
system_kalman.makesignals(t = smooth) sig_total sig_tob
system_kalman.makestates(t = smoothse) sm_sys_se_*
if @isobject("grafika") then
   delete grafika
endif
graph grafika.line sm_sys_YGAP sm_sys_YGAP+1.65*sm_sys_se_YGAP sm_sys_YGAP-1.65*sm_sys_se_YGAP 0 CPI_yy
grafika.options linepat
grafika.setelem(1) legend("YGAP") lcolor(red) lwidth(1) linepattern(1)
grafika.setelem(2) legend("+/-2 SE") lcolor(red) lwidth(1) linepattern(7)
grafika.setelem(3) legend("+/-2 SE") lcolor(red) lwidth(1) linepattern(7)
grafika.setelem(4) legend("0") lcolor(black) lwidth(1) linepattern(1)
grafika.setelem(5) legend("CPI") lcolor(blue) lwidth(1) linepattern(1)
show grafika


