'##############################
'### ROZDZIAL 8 ###############
'##############################
'### Kointegracja panelowa ###
'##############################
'### (C) Piotr Roszkowski #####
'##############################

'------------------------Wstp-------------------------------------------------------------------
'wczytanie danych - zdeklaruj ciek z plikiem
wfopen C:\zastosowania_ekonometrii_www\08\rozdzial_8.wf1
'wybierz Polsk
pageselect Polska
'prba 
smpl 2000Q1 @last

'=============MODEL NA SZEREGU DLA POLSKI=================
'-----------------------Test stacjonarnoci dla Polski--------------------------------------
logrer.uroot
logrer.uroot(dif = 1)
rir.uroot
rir.uroot(dif = 1)
debt.uroot
debt.uroot(dif = 1)
debt.uroot(dif = 2)
LOGHBS.uroot
LOGHBS.uroot(dif = 1)
logtot.uroot
logtot.uroot(dif = 1)

'-----------------------------KPSS-------------------------------------------------------------------

debt.uroot(kpss)
debt.uroot(kpss,dif = 1)

'--------------------------TEST KOINTEGRACJI DLA POLSKI--------------------------------

'-------------------------------------Procedura Engle'a Grangera-------------------------------------------
'ograniczenie prby do samej Polski
smpl 2000Q1 @last

'testy kointegracji 
coint(method = eg, maxlag = 3,lagtype = sic) LOGRER RIR DEBT NFA LOGHBS LOGTOT 

'oszacowania i istotno
'KMNK - szereg dla Polski
LS  LOGRER RIR DEBT NFA LOGHBS LOGTOT

'================MODEL PANELOWY==============================
'-------------------------Testy stacjonarnoi (panel)---------------------------------------------

'wybierz panel
pageselect panel
smpl @all

logrer.uroot(hac = bt, band = 4)
logrer.uroot(hac = bt, band = 4, dif = 1)
rir.uroot(hac = bt, band = 4)
rir.uroot(hac = bt, band = 4, dif = 1)
debt.uroot(hac = bt,band = 4)
debt.uroot(hac = bt, band = 4, dif = 1)
nfa.uroot(hac = bt, band = 4)
nfa.uroot(hac = bt, band = 4, dif = 1)
LOGHBS.uroot(hac = bt, band = 4)
LOGHBS.uroot(hac = bt, band = 4, dif = 1)
logtot.uroot(hac = bt, band = 4)
logtot.uroot(hac = bt, band = 4, dif = 1)

'----------------------Testy kointegracji panelowej-------------------------------------------

coint(pedroni, maxlag = 3, info = sic, band = 4) LOGRER RIR DEBT NFA LOGHBS LOGTOT 
coint(kao, maxlag = 3, info = sic, band = 4) LOGRER RIR DEBT NFA LOGHBS LOGTOT 

'----------------------Estymacja modeli----------------------------------------------------------

equation model1
model1.COINTREG(BW = 4, PANMETHOD = WEIGHTED)  LOGRER RIR DEBT NFA LOGHBS LOGTOT

'analiza reszt
model1.hist

series residsaved = resid
residsaved.uroot(hac = bt, band=  nw)


'procentowe niedopasowanie kursu
model1.makeresid(s) reszty_1
reszty_1 = exp(reszty_1) - 1


'===========TESTY STABILNOSCI / ANALIZA WRALIWOCI===========

'--------------------Rekursywny test stabilnoci parametrw-----------------------------
'--------------------------------------------------------------------------------------------------------

		equation eq1
		smpl 2003Q1 @last 
		!n2 = @obssmpl/4
		'liczba iteracji
		!nrolls = !n2
		
		'macierze do przechowywania oszacowa i bdw std.
		matrix(!nrolls, 5) coefmat2 
		matrix(!nrolls, 5) stdmat2
		'licznik ju wykonanych oszacowa
		!j = 1
		
		'poszerzamy okno o jedn obserwacj
		for !i = 1  to  !nrolls
  		
   		' wasciwa procedura
   			smpl @first 2003Q1 + !j 
   		
 			eq1.cointreg(method = fmols, panmethod = weighted, kern = bart, bw = 4 ) LOGRER RIR DEBT NFA LOGHBS LOGTOT
   			'store coefficients
			'eq1.@coefs(6)
			rowplace(coefmat2, @transpose(eq1.@coefs), !j)
			rowplace(stdmat2, @transpose(eq1.@stderrs), !j)
			!j = !j + 1
		next
		
		show coefmat2
		show stdmat2
'------------------------------------Analiza stabilnoci ze wzgldu na skad panelu-----------------------------
'bez Czech
smpl 2000Q1 @last if country_id <> 2
equation model1
model1.COINTREG(BW = 4, PANMETHOD = WEIGHTED)  LOGRER RIR DEBT NFA LOGHBS LOGTOT

'bez Wgier
smpl 2000Q1 @last if country_id <> 3
equation model1
model1.COINTREG(BW = 4, PANMETHOD = WEIGHTED)  LOGRER RIR DEBT NFA LOGHBS LOGTOT

'bez Polski
smpl 2000Q1 @last if country_id <> 4
equation model1
model1.COINTREG(BW = 4, PANMETHOD = WEIGHTED)  LOGRER RIR DEBT NFA LOGHBS LOGTOT

'bez Rumunii
smpl 2000Q1 @last if country_id <> 5
equation model1
model1.COINTREG(BW = 4, PANMETHOD = WEIGHTED)  LOGRER RIR DEBT NFA LOGHBS LOGTOT




'---------------------------------------Zakoczenie pracy---------------------------------------------------------
wfsave C:\zastosowania_ekonometrii_www\08\rozdzial_8_edit.wf1


